(defun c:Asciitabelle()

  (command "-layer" "n" "raster" "")
  
  (setq x 0.0)
  (setq y 7800.0)
  (setq z 0.0)
  
  (setq I 0)
  (repeat 10 
    (setq x (* I 200.0))
    (setq TXT (strcat "%%U" (itoa I)))
    (command "_TEXT" (list x y z) 100.0 0.0 TXT)
    (setq I (+ I 1))
    (command "_layer" "se" "raster" "")
    (command "_line" (list x 2900.0 0) (list x 8000.0 0) "")
    (command "_layer" "se" "0" "")
  )

  
  (setq x -800.0)
  (setq I 3)
  (repeat 23
    (setq y (- 8000.0 (* I 200)))
    (setq TXT (strcat "%%U" (itoa (* I 10))))
    (command "_TEXT" (list x y z) 100.0 0.0 TXT)
    (setq I (+ I 1))
    (command "_layer" "se" "raster" "")
    (command "_line" (list -850.0 y 0) (list 1900.0 y 0) "")
    (command "_layer" "se" "0" "")
  )
    
    
  (setq J 3)
  (repeat 23
    (setq I 0)
    (while (< I 9)
      (if (AND (= j 3) (< I 2))
        (setq I 2)
      )
      (setq x (* I 200.0))
      (setq y (- 8000.0 (* J 200)))
      (setq TXT (chr (+ (* J 10) I)))
      (command "_TEXT" (list x y z) 100.0 0.0 TXT)

      (setq I (+ I 1))
      (if (AND (= j 25) (> I 5))
        (setq I 9)
      )
    )
    (setq J (+ J 1))
  )
)
      
,++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


(defun runden (zahl stellen)
  (atof (rtos zahl 2 stellen))
) ; defun

(defun kommazaehlen (zeichenkette);/ zeichenzaehler zkanz)
  (setq zkanz (strlen zeichenkette))
  (setq zeichenzaehler 1)
  (setq kommas 0)
  (repeat zkanz
    (if (= (substr zeichenkette zeichenzaehler 1) ",")
      (setq kommas (+ kommas 1))
    )
    (setq zeichenzaehler (+ 1 zeichenzaehler))
  )
  (setq kommas kommas)
)


(defun C:SERZ ()
  (C:SCHRIFTERZEUG)
) ;_ defun

(defun C:SCHRIFTERZEUG ()
 ; / Datei buchstnummer spunkt buchst zaehler anz altpunkt
 ; bytezaehler
 ; buchstdef plist elem p elem x y xmax ymax xdiff ydiff bnummer
 ; buchstname maxlaeng aktlaeng

 ; Dieses Programm erzeugt die Definition von Buchstaben anhand von
 ; Polylinien!!

 ; Datei auswhlen
 ; Ein eventuell vorher gewhlter Dateiname wird als Vorgabe genutzt
  (if dateiname
    (setq dateiname (getfiled "Schriftdefinitionsdatei whlen..."
                              dateiname
                              "shp"
                              5
                    ) ; getfiled
    ) ; setq
    (setq dateiname (getfiled "Schriftdefinitionsdatei whlen..."
                              ""
                              "shp"
                              5
                    ) ; getfiled
    ) ; setq
  ) ; if

 ; Datei ffnen

  (setq Datei (open dateiname "w"))

 ; Datei Kopf schreiben

  (princ (strcat
           "*0,4,"
           dateiname
           "\n100,50,2,0\n*10,5,cr\n2,8,(0,-120),0\n*32,5,sp\n2,8,(75,0),0\n"
         ) ;_ strcat
         datei
  ) ; princ

  (setq buchstnummer 32) ; ASCII-Code initialisieren fr Vorschlag

  (setq maxlaeng 50) ; ungefhre Lnge der Dateizeile



 ; BEGINN Buchstabendefinition

  (setq spunkt (getpoint "Einfgepunkt: "))
 ; erster Einfgepunkt um in die Schleife zu kommen


  (while spunkt
 ; solange ein Einfgepunkt angegeben wird werden Buchstaben
 ; definiert
 ; (Abfrage am Ende der Schleife)

    (setq spunkt (list (car spunkt) (cadr spunkt))) ; Punkt zu 2D-Punkt machen

    (setq buchst (ssget '((0 . "LWPOLYLINE"))))
 ; Polylinien auswhlen fr Definition

    (setq aktlaeng 50) ; Zur berprfung der Zeilelnge

    (setq xmax 0)

    (setq zaehlerpl 0) ; Zaehler Polylinien initialisieren
    (setq zaehler 0) ; Zaehler Punkte initialisieren

    (if buchst ; Anzahl der PLinien ermitteln
      (setq anz (sslength buchst))
      (setq anz 0)
    ) ; if

    (setq altpunkt spunkt) ; Vorgngerpunkt initialisieren
    (setq bytezaehler 0) ; Zhler fr Anzahl der BYTES initialisieren
    (setq buchstdef "") ; Buchstabendefinition Initialisieren


    (while (< zaehlerpl (+ anz)) 			; Fr jede Polylinie
      (setq plist ()) 					; Punkteliste leeren
      (foreach elem (entget (ssname buchst zaehlerpl))
 							; Fr jeden Code der Plinie
        (if (= (car elem) 10) 				; Wenn Punkt dann in Punktliste
          (progn
            (setq p (list (cadr elem) (caddr elem)))
            (setq plist (append plist (list p)))
          ) ; progn
        ) ; if
      ) ; foreach elem

      (setq plist (append (list (last plist)) plist))

      (setq zaehler 0)				 	; Zaehler fr Punkteliste reinitialisieren

      (setq buchstdef (strcat buchstdef "2,")) 		; Stift heben

      (foreach punkt plist 				; Fr jeden Punkt
        (if (= zaehler 1) 				; nach dem ersten Punkt
          (progn
            (setq buchstdef (strcat buchstdef "1,")) 	; Stift senken
          ) ; progn
        ) ; if

        (setq x (runden (car punkt) 0)) 		; Koordinaten
        (setq y (runden (cadr punkt) 0))

        (if (> x xmax) 					; Maximales x fr Endpunkt
          (setq xmax x)
        ) ; if

        (if (> y ymax)
          (setq ymax y)
        ) ; if

        (setq
          xdiff (- x (runden (car altpunkt) 0))
 							; Verschiebung horizontal
        ) ; setq

        (setq
          ydiff (- y (runden (cadr altpunkt) 0))
 							; Verschiebung vertikal
        ) ; setq

        (setq altpunkt punkt) 				; vorhergehenden Punkt neu initialisieren

 							; Buchstabendefinition erstellen
        (setq buchstdef (strcat buchstdef
                                "8,("
                                (rtos xdiff 2 0)
                                ","
                                (rtos ydiff 2 0)
                                "),"
                        ) ; strcat
        ) ; setq

        (if (> (strlen buchstdef) aktlaeng)
          (progn
            (setq buchstdef (strcat buchstdef "\n"))
 							; Lnge der Zeilen begrenzen
            (setq aktlaeng (+ aktlaeng maxlaeng))
          ) ;_ progn
        ) ;_ if

        (setq zaehler (+ zaehler 1)) 			; Zaehler erhhen
      ) ; foreach punkt


      
      (setq zaehlerpl (+ zaehlerpl 1))

    ) ; while (< zaehlerpl anz)

    ; Letzten Punkt erstellen
    (setq buchstdef (strcat buchstdef
                            "2,8,("
                            (rtos (- xmax x) 2 0)
                            ","
                            (rtos (- (cadr spunkt) y) 2 0)
                            "),"
                    ) ; strcat
    ) ; setq 


    (setq buchstdef (strcat buchstdef "1,0"))		; Buchstabe mit Stift senken beenden




    (setq 						; ASCII-Code abfragen
      bnummer (getint
                (strcat "ASCII-Code <" (itoa (1+ buchstnummer)) ">")
 ; Vorschlag
              ) ; getint
    ) ; setq
    (if bnummer ; Wenn Vorschlag nicht angenommen
      (setq buchstnummer bnummer)
      (setq buchstnummer (+ buchstnummer 1))
    ) ; if
    (setq buchstname (getstring "Name: ")) ; Name fr Buchstabe

(setq bytezaehler (+ (kommazaehlen buchstdef) 1))
    
    (princ (strcat "*" 					; erste Zeile Buchstabendefinition schreiben
                   (itoa buchstnummer)
                   ","
                   (itoa bytezaehler)
                   ","
                   buchstname
                   "\n"
           ) ; strcat
           datei
    ) ; princ
    (princ (strcat buchstdef "\n") datei)
 							; zweite Zeile Buchstabendefinition schreiben
    (princ "Nchster Buchstabe:\n")
    (setq spunkt (getpoint "Einfgepunkt: ")) 		; Nchster Buchstabe
  ) ; while spunkt


  (close datei)
) ; defun 





